<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once JPATH_BASE.'/components/com_community/libraries/core.php';

class plgCommunityRSMembership extends CApplications
{
	var $name 		= "RSMembership! Application";
	var $_name		= 'rsmembership';
	var $_path		= '';
	var $_user		= '';
	var $_my		= '';

    function __construct(& $subject, $config)
    {
    	$this->_path	= JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/rsmembership.php';
		$this->_user	= CFactory::getActiveProfile();
		$this->_my		= CFactory::getUser();
		parent::__construct($subject, $config);
    }

	/**
	 * Return Itemid for RSMembership!
	 */
	function getItemid()
	{
		$Itemid = (int) $this->params->get('itemid');
		if (empty($Itemid))
			$Itemid = JFactory::getApplication()->input->get('Itemid', '', 'int');

	    return $Itemid;
	}
	
	function onProfileDisplay()
	{
		// Load language
		$this->loadLanguage( 'plg_community_rsmembership', JPATH_ADMINISTRATOR );

		// Attach CSS
		JHtml::stylesheet('plg_community_rsmembership/style.css', array('relative' => true));

		if (!file_exists($this->_path)) {
			$content  = '<div class="icon-nopost"><img src="'.JUri::base().'components/com_community/assets/error.gif" alt="" /></div>';
			$content .= '<div class="content-nopost">'.JText::_('PLG_RSMEMBERSHIP_NOT_INSTALLED').'</div>';
		} else {
			require_once $this->_path;

			$user		 = CFactory::getActiveProfile();
			$userName    = $user->getDisplayName();
			$userId 	 = $user->id;
			$memberships = $this->_getMemberships();
			$Itemid 	 = $this->getItemid();

			$cache = JFactory::getCache('plgCommunityRSMembership');
			$cache->setCaching($this->params->get('cache', 1));
			$callback = array('plgCommunityRSMembership', '_getRSMembershipHTML');

			$content = $cache->call($callback, $userName, $userId, $memberships, $Itemid);
		}
		return $content;
	}

	static public function _getRSMembershipHTML($userName, $userId, $memberships, $Itemid)
	{
		ob_start();
		$content 	= '';

		if(!$memberships)
		{
			?>
			<div class="icon-nopost">
				<?php echo JHtml::image('plg_community_rsmembership/favicon.gif', '', null, true); ?>
			</div>
			<div class="content-nopost">
				<?php echo JText::sprintf('PLG_RSMEMBERSHIP_NO_MEMBERSHIPS', $userName); ?>
			</div>
			<?php
		}
		else
		{
		?>
			<div id="community-rsmembership-wrap">
			  <div class="ctitle"></div>
				<table class="table table-striped table-hover table-condensed">
					<tr>
						<th align="left"><?php echo JText::_('PLG_RSMEMBERSHIP_MEMBERSHIPS') ?></th>
						<th align="right"><?php echo JText::_('PLG_RSMEMBERSHIP_STARTED') ?></th>
						<th align="right"><?php echo JText::_('PLG_RSMEMBERSHIP_EXPIRES') ?></th>
					</tr>
				<?php foreach ($memberships as $membership) { ?>
					<tr>
						<td valign="top" width="43%">
							<?php echo JHtml::image('plg_community_rsmembership/favicon.gif', '', null, true); ?>
							<a class="btn btn-small btn-link" href="<?php echo JRoute::_('index.php?option=com_rsmembership&view=membership&cid='.$membership->id.':'.JFilterOutput::stringURLSafe($membership->name).'&Itemid='.$Itemid); ?>"><?php echo $membership->name; ?></a>
						</td>
						<td align="right">
						<?php echo RSMembershipHelper::showDate($membership->membership_start); ?>
						</td>	
						<td align="right">
						<?php echo $membership->membership_end != '0000-00-00 00:00:00' ? RSMembershipHelper::showDate($membership->membership_end) : JText::_('PLG_RSMEMBERSHIP_UNLIMITED'); ?>
						
						</td>
					</tr>
				<?php } ?>
				</table>
			</div>
		<?php
		}
		
		$content = ob_get_contents();
		ob_end_clean();
		
		return $content;
	}
	
	/**
	 * Returns the list of memberships and its properties for the specific browsed user
	 * 
	 * @access private
	 * 
	 * returns	Array	An array of object list
	 **/	 	
	public function _getMemberships()
	{
		$db		= JFactory::getDBO();
		$limit	= '10';
		
		$db->setQuery("SELECT * FROM #__rsmembership_membership_subscribers s LEFT JOIN #__rsmembership_memberships m ON (s.membership_id = m.id) WHERE s.`user_id`='".$this->_user->id."'");		
		return $db->loadObjectList();
	}
}