<?php
/**
* @package RSMembership!
* @copyright (C) 2009-2018 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgSystemRSMRsmailInstallerScript
{
	public function preflight($type, $parent) {
		if ($type == 'uninstall') {
			return true;
		}

		$app = JFactory::getApplication();

		if (!file_exists(JPATH_ADMINISTRATOR.'/components/com_rsmembership/rsmembership.php')) {
			$app->enqueueMessage('Please install the RSMembership! component before continuing.', 'error');
			return false;
		}

		if (!file_exists(JPATH_ADMINISTRATOR.'/components/com_rsmail/rsmail.php')) {

			$app->enqueueMessage('Please install the RSMail! component before continuing.', 'error');
			return false;
		}
		
		$jversion = new JVersion();
		if (!$jversion->isCompatible('3.0.0')) {
			$app->enqueueMessage('Please upgrade to at least Joomla! 3.0.0 before continuing!', 'error');
			return false;
		}
		
		return true;
	}
	
	public function update($parent) {
		$this->copyFiles($parent);
	}
	
	public function install($parent) {
		$this->copyFiles($parent);
	}
	
	protected function copyFiles($parent) {
		$app = JFactory::getApplication();
		$installer = $parent->getParent();
		$src = $installer->getPath('source').'/admin';
		$dest = JPATH_ADMINISTRATOR.'/components/com_rsmembership';
		
		if (!JFolder::copy($src, $dest, '', true)) {
			$app->enqueueMessage('Could not copy to '.str_replace(JPATH_SITE, '', $dest).', please make sure destination is writable!', 'error');
		}
	}
}