<?php
/**
* @package RSMembership!
* @copyright (C) 2009-2018 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');

class plgSystemRSMembershipPaypalInstallerScript
{
	public function preflight($type, $parent) {
		if ($type == 'uninstall') {
			return true;
		}
		
		$app = JFactory::getApplication();
		
		if (!file_exists(JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/rsmembership.php')) {
			$app->enqueueMessage('Please install the RSMembership! component before continuing.', 'error');
			return false;
		}
		
		if (file_exists(JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/version.php')) {
			require_once JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/version.php';
			$version = (string) new RSMembershipVersion();
			if (version_compare($version,'1.22.15','<')) {
				$app->enqueueMessage('Please upgrade to at least RSMembership! Version 1.22.15 before continuing!', 'error');
				return false;
			}
		} else {
			$app->enqueueMessage('Please upgrade RSMembership! to the latest version before continuing!', 'error');
			return false;
		}
		
		$jversion = new JVersion();
		if (!$jversion->isCompatible('3.0.0')) {
			$app->enqueueMessage('Please upgrade to at least Joomla! 3.0.0 before continuing!', 'error');
			return false;
		}
		
		return true;
	}
	
	public function postflight($type, $parent) {
		if ($type == 'uninstall') {
			return true;
		}
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('extension_id')
			  ->from($db->qn('#__extensions'))
			  ->where($db->qn('type').' = '.$db->q('plugin'))
			  ->where($db->qn('folder').' = '.$db->q('system'))
			  ->where($db->qn('element').' = '.$db->q('rsmembershippaypal'));
		$pluginId = $db->setQuery($query)->loadResult();
		
		$jversion = new JVersion;
		?>
		<style type="text/css">
		.version-history {
			margin: 0 0 2em 0;
			padding: 0;
			list-style-type: none;
		}
		.version-history > li {
			margin: 0 0 0.5em 0;
			padding: 0 0 0 4em;
			text-align:left;
			font-weight:normal;
		}
		.version-new,
		.version-fixed,
		.version-upgraded {
			float: left;
			font-size: 0.8em;
			margin-left: -4.9em;
			width: 4.5em;
			color: white;
			text-align: center;
			font-weight: bold;
			text-transform: uppercase;
			-webkit-border-radius: 4px;
			-moz-border-radius: 4px;
			border-radius: 4px;
		}

		.version-new {
			background: #7dc35b;
		}
		.version-fixed {
			background: #e9a130;
		}
		.version-upgraded {
			background: #61b3de;
		}
		</style>

		<h3>RSMembership! PayPal Plugin v1.1.11 Changelog</h3>
		<ul class="version-history">
			<li><span class="version-upgraded">Upg</span> PayPal IPNs updated to new URLs (ipnpb.paypal.com and ipnpb.sandbox.paypal.com)</li>
			<li><span class="version-upgraded">Upg</span> When a connection error is encountered, a 500 error is now shown so that the PayPal IPN is retried.</li>
			<li><span class="version-upgraded">Upg</span> Switched from cURL to Joomla!'s JHttp class.</li>
		</ul>
		<?php if ($pluginId) { ?>
		<a class="btn btn-primary btn-large" href="<?php echo JRoute::_('index.php?option=com_plugins&task=plugin.edit&extension_id='.$pluginId); ?>">Start using the RSMembership! PayPal Plugin.</a>
		<?php } ?>
		<a class="btn" href="https://www.rsjoomla.com/support/view-article/312-rsmembership-paypal-payment-plugin.html" target="_blank">Read the documentation</a>
		<a class="btn" href="https://www.rsjoomla.com/support.html" target="_blank">Get Support!</a>
		<div style="clear: both;"></div>
		<?php
	}
}