<?php
/**
* @package RSMembership!
* @copyright (C) 2009-2015 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');

class plgSystemRSMembershipAuthorizeInstallerScript
{	
	public function preflight($type, $parent) {
		if ($type == 'uninstall') {
			return true;
		}
		
		$app = JFactory::getApplication();
		
		if (!file_exists(JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/rsmembership.php')) {
			$app->enqueueMessage('Please install the RSMembership! component before continuing.', 'error');
			return false;
		}
		
		if (file_exists(JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/version.php')) {
			require_once JPATH_ADMINISTRATOR.'/components/com_rsmembership/helpers/version.php';
			$version = (string) new RSMembershipVersion();
			if (version_compare($version,'1.22.15','<')) {
				$app->enqueueMessage('Please upgrade to at least RSMembership! Version 1.22.15 before continuing!', 'error');
				return false;
			}
		} else {
			$app->enqueueMessage('Please upgrade RSMembership! to the latest version before continuing!', 'error');
			return false;
		}
		
		$jversion 	= new JVersion();
		
		// Running Joomla! < 3.7.0
		if (!$jversion->isCompatible('3.7.0'))
		{
			$app->enqueueMessage('Please upgrade to at least Joomla! 3.7.0 before continuing!', 'error');
			return false;
		}
		
		$this->copyFiles($parent);

		return true;
	}
	
	protected function copyFiles($parent) {
		$app = JFactory::getApplication();
		$installer = $parent->getParent();
		$src = $installer->getPath('source').'/admin';
		$dest = JPATH_ADMINISTRATOR.'/components/com_rsmembership';

		if (!JFolder::copy($src, $dest, '', true)) {
			$app->enqueueMessage('Could not copy to '.str_replace(JPATH_SITE, '', $dest).', please make sure destination is writable!', 'error');
		}
	}
	
	public function postflight($type, $parent) {
		if ($type == 'uninstall') {
			return true;
		}
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('extension_id')
			  ->from($db->qn('#__extensions'))
			  ->where($db->qn('type').' = '.$db->q('plugin'))
			  ->where($db->qn('folder').' = '.$db->q('system'))
			  ->where($db->qn('element').' = '.$db->q('rsmembershipauthorize'));
		$pluginId = $db->setQuery($query)->loadResult();
		
		$jversion = new JVersion;
		?>
		<style type="text/css">
		.version-history {
			margin: 0 0 2em 0;
			padding: 0;
			list-style-type: none;
		}
		.version-history > li {
			margin: 0 0 0.5em 0;
			padding: 0 0 0 4em;
			text-align:left;
			font-weight:normal;
		}
		.version-new,
		.version-fixed,
		.version-upgraded {
			float: left;
			font-size: 0.8em;
			margin-left: -4.9em;
			width: 4.5em;
			color: white;
			text-align: center;
			font-weight: bold;
			text-transform: uppercase;
			-webkit-border-radius: 4px;
			-moz-border-radius: 4px;
			border-radius: 4px;
		}

		.version-new {
			background: #7dc35b;
		}
		.version-fixed {
			background: #e9a130;
		}
		.version-upgraded {
			background: #61b3de;
		}
		</style>

		<h3>RSMembership! Authorize.Net Plugin v1.4.0 Changelog</h3>
		<ul class="version-history">
			<li><span class="version-upgraded">Upg</span> Authorize.Net API has been updated to the newest version.</li>
		</ul>
		<?php if ($pluginId) { ?>
		<a class="btn btn-primary btn-large" href="<?php echo JRoute::_('index.php?option=com_plugins&task=plugin.edit&extension_id='.$pluginId); ?>">Start using the RSMembership! Authorize.Net Plugin.</a>
		<?php } ?>
		<a class="btn" href="https://www.rsjoomla.com/support/documentation/view-article/566-rsmembership-authorizenet-plugin.html" target="_blank">Read the documentation</a>
		<a class="btn" href="https://www.rsjoomla.com/support.html" target="_blank">Get Support!</a>
		<div style="clear: both;"></div>
		<?php
	}
}